<?php

declare(strict_types=1);

namespace Seka\Terminy\Http\Controllers\Backend\Registracie\Livewire\Components;

use Exception;
use Livewire\Component;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Log;
use App\Models\Pouzivatel\Pouzivatel;
use App\Models\Pracovisko\Pracovisko;
use Seka\Terminy\Models\Udalost\Udalost;
use Elceka\Laravel\HashId\Facades\Hasher;
use Illuminate\Database\Eloquent\Collection;
use Seka\Terminy\Actions\CreateRegistration;
use Seka\Terminy\Exceptions\TerminyException;
use Seka\Terminy\Models\Registracia\Registracia;
use Illuminate\Database\Eloquent\ModelNotFoundException;
use Illuminate\Foundation\Auth\Access\AuthorizesRequests;

/**
 * Class Form
 *
 * @package Seka\Terminy\Http\Controllers\Backend\Registracie\Livewire\Components
 */
final class Form extends Component
{
    use AuthorizesRequests;

    /**
     * @var \Seka\Terminy\Models\Udalost\Udalost
     */
    public Udalost $udalost;

    /**
     * @var \Illuminate\Database\Eloquent\Collection
     */
    public Collection $pouzivatelia;

    /**
     * @var \Seka\Terminy\Models\Registracia\Registracia
     */
    public Registracia $registracia;

    /**
     * @var \App\Models\Pouzivatel\Pouzivatel
     */
    public Pouzivatel $pouzivatel;

    /**
     * @var \Illuminate\Database\Eloquent\Collection
     */
    public Collection $pracoviska;

    /**
     * @var \App\Models\Pracovisko\Pracovisko
     */
    public Pracovisko $pracovisko;

    /**
     * @param \Seka\Terminy\Models\Udalost\Udalost $udalost
     */
    public function mount(Udalost $udalost): void
    {
        $this->udalost = $udalost;
        $this->pouzivatel = new Pouzivatel();
        $this->pracovisko = new Pracovisko();
        $this->pouzivatelia = new Collection();
        $this->registracia = new Registracia();
    }

    /**
     * @return mixed
     * @throws \Illuminate\Contracts\Container\BindingResolutionException
     */
    public function render()
    {
        $this->pracoviska = Pracovisko::query()->get();
        $this->pouzivatelia = Pouzivatel::query()
            ->with('pracovisko')
            ->aktivny()
            ->orderBy('login')
            ->get();

        return view('Terminy::pages.udalosti.registracie.backend.livewire.components.form');
    }

    /**
     * @param $value
     * @param $attribute
     *
     * @throws \Illuminate\Contracts\Container\BindingResolutionException
     */
    public function updatedPouzivatel($value, $attribute)
    {
        // ak bol pouzivatel odznaceny, tak premanna pouzivatela sa musi vyprazdnit
        if (empty($value)) {
            $this->pouzivatel = new Pouzivatel();
        }

        // ak bol zmeneny pouzivatel, tak sa premenna pouzivatela nastavi ziskanym objektom daneho pouzivatela
        // zaroven sa vyprazdni premenna registracie
        if ($attribute === 'hash_id') {
            $id = Hasher::decode($value);
            $this->pouzivatel = Pouzivatel::query()->aktivny()->findOrFail($id);
            $this->registracia = new Registracia();
        }
    }

    /**
     * @param $value
     * @param $attribute
     */
    public function updatedRegistracia($value, $attribute)
    {
        // ak bola zadana hodnota atributu pre registraciu, tak premenna pouzivatela sa musi vyprazdnit
        if (! empty($value)) {
            $this->pouzivatel = new Pouzivatel();
        }

        if ($attribute === 'pracovisko_id') {
            $id = Hasher::decode($value);
            $this->pracovisko = Pracovisko::query()->findOrFail($id);
        }
    }

    /**
     * @param \Seka\Terminy\Actions\CreateRegistration $createRegistration
     *
     * @return \Illuminate\Http\RedirectResponse|\Livewire\Redirector
     * @throws \Illuminate\Contracts\Container\BindingResolutionException
     * @throws \Illuminate\Validation\ValidationException
     * @throws \Throwable
     */
    public function create(CreateRegistration $createRegistration)
    {
        $this->authorize('terminy.registracie.vytvorit');
        $this->validate();

        try {
            $pek = null;

            DB::beginTransaction();

            $this->registracia->vytvoril()->associate(auth()->user());

            if ($this->pouzivatel->exists) {
                $this->registracia->pouzivatel()->associate($this->pouzivatel);
                $pek = $this->pouzivatel->pracovisko;
            }

            if ($this->pracovisko->exists) {
                $pek = $this->pracovisko;
            }

            $createRegistration::execute($this->udalost, auth()->user(), $pek, $this->registracia);

            DB::commit();

            flash()->overlay('Registrácia používateľa na udalosť bola úspešná.', 'Hlásenie')->success();
        } catch (ModelNotFoundException $e) {
            flash()->overlay('Udalosť nebola nájdená.', 'Hlásenie')->warning();
        } catch (TerminyException $e) {
            flash()->overlay($e->getMessage(), 'Hlásenie')->warning();
        } catch (Exception $e) {
            DB::rollBack();
            Log::error($e->getMessage(), $e->getTrace());
            flash()->overlay('Chyba', 'Hlásenie')->error();
        } finally {
            return redirect()->route('modul.terminy.backend.udalosti.udalost.registracie.index', $this->udalost);
        }
    }

    /**
     * @return string[]
     */
    public function rules(): array
    {
        return [
            'pouzivatel.hash_id' => 'required_without_all:registracia.meno,registracia.priezvisko',
            'registracia.meno' => 'required_without:pouzivatel.id|max:30',
            'registracia.priezvisko' => 'required_without:pouzivatel.id|max:30',
            'registracia.pracovisko_id' => 'required_without:pouzivatel.id',
            'registracia.poznamka' => 'max:500',
        ];
    }

    /**
     * @return string[]
     */
    public function messages(): array
    {
        return [
            'pouzivatel.hash_id.required_without_all' => 'Voľba používateľa sa vyžaduje ak nebol zadaný manuálne',
            'registracia.meno.required_without' => 'Meno používateľa sa vyžaduje ak používateľ nebol zvolený zo zoznamu používateľov',
            'registracia.meno.max' => 'Meno používateľa smie obsahovať maximálne :max znakov',
            'registracia.priezvisko.required_without' => 'Priezvisko používateľa sa vyžaduje ak používateľ nebol zvolený zo zoznamu používateľov',
            'registracia.priezvisko.max' => 'Priezvisko používateľa smie obsahovať maximálne :max znakov',
            'registracia.pracovisko_id.required_without' => 'Pracovisko používateľa sa vyžaduje ak používateľ nebol zvolený zo zoznamu používateľov',
            'registracia.poznamka.max' => 'Poznámka smie obsahovať maximálne :max znakov',
        ];
    }
}
